New issue

Have a question about this project? Sign up for a free GitHub account to open an issue and contact its maintainers and the community.

By clicking “Sign up for GitHub”, you agree to our terms of service and privacy statement. We’ll occasionally send you account related emails.

Already on GitHub? Sign in to your account

pip broken on Python 3.1 #1513

Closed
MvGulik opened this Issue Jan 28, 2014 · 9 comments

Comments

Projects
None yet
4 participants
@MvGulik

MvGulik commented Jan 28, 2014

Splitting off the "pip broken on Python 3.1" part from issue #1503
(1503 Issue report contains additional information on this.)

@lig

This comment has been minimized.

Show comment
Hide comment
@lig

lig Jan 28, 2014

should be labeled "py31"

lig commented Jan 28, 2014

should be labeled "py31"

@lig

This comment has been minimized.

Show comment
Hide comment
@lig

lig Jan 28, 2014

Nice traceback from @MvGulik

C:\Python31>python get-pip2.py
Traceback (most recent call last):
File "c:\docume1\admini1\locals~1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages\ssl_match_hostname__init__.py", line 3,
in
ImportError: cannot import name CertificateError

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File "c:\docume1\admini1\locals~1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages\ssl_match_hostname__init__.py", line 7,
in
ImportError: No module named backports.ssl_match_hostname

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File "get-pip2.py", line 16415, in
do_exec(entry, locals())
File "", line 1, in do_exec
File "", line 2, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip__init__.py", line 11, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip\vcs\mercurial.py", line 9, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip\download.py", line 22, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests__init__.py", line 58, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\utils.py", line 25, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\compat.py", line 7, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages__init__.py", line 3, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3__init__.py", line 16, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\connectionpool.py", line 31, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages__init__.py", line 3, in
File "c:\docume1\admini1\locals~1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages\ssl_match_hostname__init__.py", line 10
, in
ImportError: No module named _implementation

lig commented Jan 28, 2014

Nice traceback from @MvGulik

C:\Python31>python get-pip2.py
Traceback (most recent call last):
File "c:\docume1\admini1\locals~1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages\ssl_match_hostname__init__.py", line 3,
in
ImportError: cannot import name CertificateError

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File "c:\docume1\admini1\locals~1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages\ssl_match_hostname__init__.py", line 7,
in
ImportError: No module named backports.ssl_match_hostname

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File "get-pip2.py", line 16415, in
do_exec(entry, locals())
File "", line 1, in do_exec
File "", line 2, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip__init__.py", line 11, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip\vcs\mercurial.py", line 9, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip\download.py", line 22, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests__init__.py", line 58, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\utils.py", line 25, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\compat.py", line 7, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages__init__.py", line 3, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3__init__.py", line 16, in
File "c:\docume1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\connectionpool.py", line 31, in
File "c:\docume
1\admini1\locals1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages__init__.py", line 3, in
File "c:\docume1\admini1\locals~1\temp\unpacker-ulvxmu-scratchdir\pip_vendor\requests\packages\urllib3\packages\ssl_match_hostname__init__.py", line 10
, in
ImportError: No module named _implementation

@MvGulik

This comment has been minimized.

Show comment
Hide comment
@MvGulik

MvGulik Jan 28, 2014

Correction: traceback did change a bit.

>"C:\Python31\python.exe" -u "get-pip3.py"
c:\docume~1\admini~1\locals~1\temp\tmp15j331
get-pip3.py:20348: DeprecationWarning: decodestring() is a deprecated alias, use decodebytes()
  fp.write(base64.decodestring(ZIPFILE))
Traceback (most recent call last):
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\ssl_match_hostname\__init__.py", line 3, in <module>
ImportError: cannot import name CertificateError

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\ssl_match_hostname\__init__.py", line 7, in <module>
ImportError: No module named backports.ssl_match_hostname

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "get-pip3.py", line 20363, in <module>
    main()
  File "get-pip3.py", line 20354, in main
    bootstrap(tmpdir=tmpdir)
  File "get-pip3.py", line 20293, in bootstrap
    import pip
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\__init__.py", line 11, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\vcs\mercurial.py", line 9, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\download.py", line 22, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\__init__.py", line 58, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\utils.py", line 25, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\compat.py", line 7, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\__init__.py", line 3, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\__init__.py", line 16, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\connectionpool.py", line 31, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\__init__.py", line 3, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\ssl_match_hostname\__init__.py", line 10, in <module>
ImportError: No module named _implementation
>Exit code: 1    Time: 2.615

MvGulik commented Jan 28, 2014

Correction: traceback did change a bit.

>"C:\Python31\python.exe" -u "get-pip3.py"
c:\docume~1\admini~1\locals~1\temp\tmp15j331
get-pip3.py:20348: DeprecationWarning: decodestring() is a deprecated alias, use decodebytes()
  fp.write(base64.decodestring(ZIPFILE))
Traceback (most recent call last):
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\ssl_match_hostname\__init__.py", line 3, in <module>
ImportError: cannot import name CertificateError

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\ssl_match_hostname\__init__.py", line 7, in <module>
ImportError: No module named backports.ssl_match_hostname

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "get-pip3.py", line 20363, in <module>
    main()
  File "get-pip3.py", line 20354, in main
    bootstrap(tmpdir=tmpdir)
  File "get-pip3.py", line 20293, in bootstrap
    import pip
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\__init__.py", line 11, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\vcs\mercurial.py", line 9, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\download.py", line 22, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\__init__.py", line 58, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\utils.py", line 25, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\compat.py", line 7, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\__init__.py", line 3, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\__init__.py", line 16, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\connectionpool.py", line 31, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\__init__.py", line 3, in <module>
  File "c:\docume~1\admini~1\locals~1\temp\tmp15j331\pip.zip\pip\_vendor\requests\packages\urllib3\packages\ssl_match_hostname\__init__.py", line 10, in <module>
ImportError: No module named _implementation
>Exit code: 1    Time: 2.615
@MvGulik

This comment has been minimized.

Show comment
Hide comment
@MvGulik

MvGulik Jan 28, 2014

Mmm.

... that pip itself is broken on Python 3.1 (well rather urllib3 which pip includes as part of it's source is).
by @dstufft

If that's http://github.com/shazow/urllib3 , then its more a urllib3 issue. ... But currently urllib3 seems to have no direct/official support for Python 3.1 anymore. (there not directly saying they have ditched 3.1 support, but I think they did.)

Options that come to my mind:

  • Convince the urllib3 group to pickup 3.1 support. In the hope this problem gets fixed on that side.
  • Add a pip specific fix to the used urllib3 package.
  • Or ... ditch pip support for 3.1. (just being pragmatic.)

I think that kinda puts me out of the loop. (not actively using 3.1, and I'm not part of the core pip and/or urllib3 group.

MvGulik commented Jan 28, 2014

Mmm.

... that pip itself is broken on Python 3.1 (well rather urllib3 which pip includes as part of it's source is).
by @dstufft

If that's http://github.com/shazow/urllib3 , then its more a urllib3 issue. ... But currently urllib3 seems to have no direct/official support for Python 3.1 anymore. (there not directly saying they have ditched 3.1 support, but I think they did.)

Options that come to my mind:

  • Convince the urllib3 group to pickup 3.1 support. In the hope this problem gets fixed on that side.
  • Add a pip specific fix to the used urllib3 package.
  • Or ... ditch pip support for 3.1. (just being pragmatic.)

I think that kinda puts me out of the loop. (not actively using 3.1, and I'm not part of the core pip and/or urllib3 group.

@Ivoz

This comment has been minimized.

Show comment
Hide comment
@Ivoz

Ivoz Jan 28, 2014

Member

I'd highly discourage using 3.1 anywhere at this point, 3.2 and 3.3 are way better and have been out for almost 3 years now.

Member

Ivoz commented Jan 28, 2014

I'd highly discourage using 3.1 anywhere at this point, 3.2 and 3.3 are way better and have been out for almost 3 years now.

@dstufft

This comment has been minimized.

Show comment
Hide comment
@dstufft

dstufft Jan 28, 2014

Member

I think we've decided to ditch support for 3.1 in pip 1.6+, unsure if we want to retroactively "remove" support (which would really just be officially adopting the fact it's broken as the policy) or if we want to fix 3.1 in 1.5.

Member

dstufft commented Jan 28, 2014

I think we've decided to ditch support for 3.1 in pip 1.6+, unsure if we want to retroactively "remove" support (which would really just be officially adopting the fact it's broken as the policy) or if we want to fix 3.1 in 1.5.

@lig

This comment has been minimized.

Show comment
Hide comment
@lig

lig Jan 29, 2014

@dstufft It is crucial for me to have working pip for 3.1. Thus I'm going to fix it myself.

lig commented Jan 29, 2014

@dstufft It is crucial for me to have working pip for 3.1. Thus I'm going to fix it myself.

@Ivoz

This comment has been minimized.

Show comment
Hide comment
@Ivoz

Ivoz Jan 29, 2014

Member

@lig I'm sure the urllib3 folks might be happy to consider a PR, which pip could eventually upstream.

Member

Ivoz commented Jan 29, 2014

@lig I'm sure the urllib3 folks might be happy to consider a PR, which pip could eventually upstream.

@dstufft

This comment has been minimized.

Show comment
Hide comment
@dstufft

dstufft Sep 11, 2014

Member

I'm going to close this. Pip 1.6+ has removed support for 3.1 and it's unlikely at this point we're going to release another 1.5.x version.

Member

dstufft commented Sep 11, 2014

I'm going to close this. Pip 1.6+ has removed support for 3.1 and it's unlikely at this point we're going to release another 1.5.x version.

@dstufft dstufft closed this Sep 11, 2014

Sign up for free to join this conversation on GitHub. Already have an account? Sign in to comment